;-----------------------------------------
;   Sprite2.asm -- A sprite animation
;   based on "C" code from Herbert Schildt's 
;   "Advanced Windows 95 Programming"
; 
;   Translated into assembly 28/4/99 by
;   Ron Thomas Ron_Thom@Compuserve.com	
;-----------------------------------------

; Animating a bitmapped sprite

.386				; 32 bit when .386 appears before .MODEL
.MODEL FLAT,STDCALL

include windows.inc

include user32.inc
include kernel32.inc
include gdi32.inc

includelib user32.lib
includelib kernel32.lib
includelib gdi32.lib

WinMain		PROTO :DWORD, :DWORD, :DWORD, :SDWORD
run		PROTO STDCALL :DWORD

.data

BITMAPSIZE	EQU	64

ClassName db "SimpleWinClass",0
AppName   db "Animating a Bitmap",0
MYBP1	  db "MYBP1",0
MYBP2	  db "MYBP2",0
MYBP3	  db "MYBP3",0

animdim		RECT		<>	; Use for animation area
r		RECT		<>
tm		TEXTMETRIC	<>

X		dd	0		; Current output location
Y		dd	20

maxX		dd	?		; Screen dimensions
maxY		dd	?

bmpdc		HDC	?		; Bitmap device handle

map		dw	?		; Bitmap switch 

hAnBit1		HBITMAP ?		; Animation bitmap handle
hAnBit2		HBITMAP	?
hAnBit3		HBITMAP	?
	
hbrush		HBRUSH	?		; Brush handle
hbit		HBITMAP	?		; Virtual bitmap handle
memdc		HDC	?		; Virtual device handle

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
;---------------------------------------------------------------------------
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
        invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD

	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
        LOCAL hwnd:HWND

	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
        push  hInstance
        pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
        invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
        mov   wc.hIconSm,0
        invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax 
        invoke RegisterClassEx, addr wc

	invoke LoadBitmap, hInst, ADDR MYBP1	; Load the 3 bitmaps
	mov	hAnBit1,eax 	
	invoke LoadBitmap, hInst, ADDR MYBP2
	mov	hAnBit2,eax 	
	invoke LoadBitmap, hInst, ADDR MYBP3
	mov	hAnBit3,eax 	

        INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
        mov   hwnd,eax
        INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
        INVOKE UpdateWindow, hwnd
        .WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE TranslateMessage, ADDR msg
                INVOKE DispatchMessage, ADDR msg
	        invoke run, hwnd			;Cycle the animation
        .ENDW
        mov     eax,msg.wParam
        ret
WinMain endp

WndProc proc   hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

        LOCAL  hdc:HDC
        LOCAL  ps:PAINTSTRUCT
		  		
	mov    eax,uMsg

	.IF	eax==WM_CREATE

	  invoke  GetSystemMetrics, SM_CXSCREEN
	  mov	  maxX,eax
	  invoke  GetSystemMetrics, SM_CYSCREEN
	  mov	  maxY,eax

;	Create a virtual window

	  invoke  GetDC, hWnd
	  mov	  hdc,eax
	  invoke  CreateCompatibleDC, hdc
	  mov	  memdc,eax
	  invoke  CreateCompatibleBitmap, hdc, maxX, maxY
	  mov	  hbit,eax
	  invoke  SelectObject, memdc, hbit
	  invoke  GetStockObject, WHITE_BRUSH
	  mov	  hbrush,eax
	  invoke  SelectObject, memdc, hbrush
	  invoke  PatBlt, memdc, 0, 0, maxX, maxY, PATCOPY

	  mov	  eax,X
	  mov	  animdim.left,eax
	  add	  eax,BITMAPSIZE
	  mov	  animdim.right,eax

	  mov	  eax,Y
	  mov	  animdim.top,eax
	  add	  eax,BITMAPSIZE
	  mov	  animdim.bottom,eax

	  invoke  CreateCompatibleDC, hdc
	  mov	  bmpdc,eax
	  invoke  SelectObject, bmpdc, hAnBit1

;	Copy bitmap to virtual window

	  invoke  BitBlt, memdc, X, Y, BITMAPSIZE, BITMAPSIZE, bmpdc, 0, 0, SRCCOPY
	  invoke  ReleaseDC, hWnd, hdc
	  invoke  InvalidateRect, hWnd, NULL, 1

        .ELSEIF eax==WM_PAINT

          invoke  BeginPaint, hWnd, ADDR ps	; Get DC

          mov	hdc,eax	 ; Get handle to device context before selecting GDI object into it

;	Copy virtual window onto screen

	  mov	eax,ps.rcPaint.right
	  sub	eax,ps.rcPaint.left
	  mov	ecx,ps.rcPaint.bottom
	  sub	ecx,ps.rcPaint.top
	
	  invoke  BitBlt, hdc,   ps.rcPaint.left, ps.rcPaint.top, eax, ecx, \ 
			  memdc, ps.rcPaint.left, ps.rcPaint.top, SRCCOPY

          invoke  EndPaint, hWnd, ADDR ps

	.ELSEIF eax==WM_DESTROY

          invoke  DeleteDC, memdc
	  invoke  DeleteDC, bmpdc
          invoke  PostQuitMessage,NULL

        .ELSE

            invoke  DefWindowProc, hWnd, uMsg, wParam, lParam
            ret

	.ENDIF
        xor    eax,eax
	ret

WndProc endp

run	Proc	hWnd:HWND

	inc	X				; Increment X position
	   
;	Get size of client area

	invoke  GetClientRect, hWnd, ADDR r	; Get current size of client area
						; as this changes with a resize
	mov	eax,X
	inc	eax

	.IF   eax > r.right			; If reach right side, reset to 0
	  mov   X,0
	.ENDIF

	inc	map				;Cycle through 3 sprites

	.IF   map > 2
	  mov	map,0
	.ENDIF

;	Switch between sprites

	.IF	map==0

	  invoke  SelectObject, bmpdc, hAnBit1

	  invoke  BitBlt, memdc, X, Y,  BITMAPSIZE, BITMAPSIZE, bmpdc,   0, 0,    SRCCOPY

;                                TLC    width dest  height dest handle    TLC     raster  
;                               coords  rectangle   rectangle   source   coords	    op   									
;                               destn                             DC     source    code
	.ELSEIF map==1

	  invoke  SelectObject, bmpdc, hAnBit2
	  invoke  BitBlt, memdc, X, Y,  BITMAPSIZE, BITMAPSIZE, bmpdc,   0, 0,    SRCCOPY

	.ELSE

	  invoke  SelectObject, bmpdc, hAnBit3
	  invoke  BitBlt, memdc, X, Y,  BITMAPSIZE, BITMAPSIZE, bmpdc,   0, 0,    SRCCOPY

	.ENDIF

	mov	eax,X			
	mov	animdim.left,eax		; Update coordinates
	add	eax,BITMAPSIZE
	mov	animdim.right,eax		;

	mov	eax,Y				
	mov	animdim.top,eax			;			
	add	eax,BITMAPSIZE
	mov	animdim.bottom,eax		;

	invoke	Sleep, 1			; Slow animation down with 1 msec delay
						; *** alter to suit your own system ***
  
	invoke	InvalidateRect, hWnd, ADDR animdim,0	; Force update of animation 
	
	ret
run	ENDP

        end start

